; Konstantenvereinbarungen
.equ PORTACFG,  0x7F93
.equ PORTCCFG,  0x7F95
.equ OEA,       0x7F9C
.equ OEC,       0x7F9E
.equ OUTA,      0x7F96
.equ PINSC,     0x7F9B

; Reset-Vektor zeigt hier hin
        .org    0x0000
        sjmp    init

; Eigenlicher Programmanfang
        .org    0x0080                 ; Sprung zu eigentlichem Programmstart
init:
        mov     dptr, #PORTACFG        ; Schiebe Adresse fr Port-A-Konfiguration nach dptr (16-bit)
        mov     a, #00000000b          ; Schiebe CFG (general purpose I/O - siehe Seite 60) nach a
        movx    @dptr, a               ; Schreibe Konfiguration an Adresse fr Port-A-Konfiguration
        mov     dptr, #PORTCCFG        ; Lade Adresse fr Port-C-Konfiguration nach dptr (16-bit)
        mov     a, #00000000b          ; Schiebe CFG (general purpose I/O - siehe Seite 60) nach a
        movx    @dptr, a               ; Schreibe Konfiguration an Adresse fr Port-C-Konfiguration

        mov     dptr, #OEA             ; Schiebe Adresse fr Port-A-Ausgabeeinstellungen nach dptr (16-bit)
        mov     a, #00110000b          ; Setze Bit fr OEA4 (rote led) & OEA5 (grne) auf 1 (rest 0->lesen)
        movx    @dptr, a               ; Schreibe Konfiguration an Adresse fr Port-A-Ausgabeeinstellungen

        mov     dptr, #OEC             ; Schiebe Adresse fr Port-C-Ausgabeeinstellungen nach dptr (16-bit)
        mov     a, #00000000b          ; Setze Bits auf 0 (alle lesen, ben�igen roten/gelben taster - siehe seite 191)
        movx    @dptr, a               ; Schreibe Konfiguration an Adresse fr Port-C-Ausgabeeinstellungen

l1:
        mov     dptr, #PINSC           ; Schiebe Adresse fr Pins an Port-C nach dprt
        movx    a, @dptr               ; lese Eingaben von Port-C nach a
        cpl     a                      ; cpl, da wieder mal low-aktiver Schalter....grml
        mov     0x20, a
        mov     c, 3
        mov     4, c
        mov     c, 2
        mov     5, c
	mov     a, 0x20
	
        mov     dptr, #OUTA            ; Schiebe Adresse fr Ausgabe an Port-A nach dprt
        movx    @dptr, a               ; gebe unser Ergebnis aus
        sjmp    l1                     ; Schleife wiederholen
