; Konstantenvereinbarungen
.equ PORTACFG,  0x7F93
.equ PORTCCFG,  0x7F95
.equ OEA,       0x7F9C
.equ OEC,       0x7F9E
.equ OUTA,      0x7F96
.equ PINSC,     0x7F9B

; Reset-Vektor zeigt hier hin
        .org    0x0000
        sjmp    init

; Eigenlicher Programmanfang
        .org    0x0080                 ; Sprung zu eigentlichem Programmstart
init:
        mov     dptr, #PORTACFG        ; Schiebe Adresse fr Port-A-Konfiguration nach dptr (16-bit)
        mov     a, #00000000b          ; Schiebe CFG (general purpose I/O - siehe Seite 60) nach a
        movx    @dptr, a               ; Schreibe Konfiguration an Adresse fr Port-A-Konfiguration
        mov     dptr, #PORTCCFG        ; Lade Adresse fr Port-C-Konfiguration nach dptr (16-bit)
        mov     a, #00000000b          ; Schiebe CFG (general purpose I/O - siehe Seite 60) nach a
        movx    @dptr, a               ; Schreibe Konfiguration an Adresse fr Port-C-Konfiguration

        mov     dptr, #OEA             ; Schiebe Adresse fr Port-A-Ausgabeeinstellungen nach dptr (16-bit)
        mov     a, #00010000b          ; Setze Bit fr OEA4 (rote led) auf 1 (rest 0->lesen)
        movx    @dptr, a               ; Schreibe Konfiguration an Adresse fr Port-A-Ausgabeeinstellungen

        mov     dptr, #OEC             ; Schiebe Adresse fr Port-C-Ausgabeeinstellungen nach dptr (16-bit)
        mov     a, #00000000b          ; Setze Bits auf 0 (alle lesen, ben�igen roten taster - siehe seite 191)
        movx    @dptr, a               ; Schreibe Konfiguration an Adresse fr Port-C-Ausgabeeinstellungen
	
	mov     r6, #0                 ; setze unseren speicher auf 0 (wir speichern immer in jedes 2. bit)

l1:
        ; Eingabe
        mov     dptr, #PINSC           ; Schiebe Adresse fr Pins an Port-C nach dprt
        movx    a, @dptr               ; lese Eingaben von Port-C nach a
	mov     0x20, a                ; speichere in bitadressierbaren speicher

        mov     c, 3                   ; speichere rote schalter in c (low aktiv!)
        jnc     roter_schalter         ; wenn roter schalter gedrckt wurde

        mov     c, 2                   ; speichere gelbe schalter in c (low aktiv!)
        jnc     gelber_schalter        ; wenn roter schalter gedrckt wurde

        ; Ausgabe
        mov     a, r6                  ; hole unsere gespeicherten nach a
        mov     dptr, #OUTA            ; Schiebe Adresse fr Ausgabe an Port-A nach dprt
        movx    @dptr, a               ; gebe unser Ergebnis aus, wenn an Stelle 4 gesetzt: LED leuchtet
        sjmp    l1                     ; Schleife wiederholen

roter_schalter:
        mov     a, r6                  ; rotiere auf nchste position
        rr      a
        rr      a
        mov     r6, a
wait_roter:
        mov     dptr, #PINSC           ; Schiebe Adresse fr Pins an Port-C nach dprt
        movx    a, @dptr               ; lese Eingaben von Port-C nach a
        mov     0x20, a                ; speichere in bitadressierbaren speicher
        mov     c, 3                   ; speichere rote schalter in c (low aktiv!)
        jnc     wait_roter             ; wenn roter schalter gedrckt ist
        sjmp    l1                     ; schalter wurde losgelassen

gelber_schalter:
        mov     a, #00010000b
        xrl     a, r6                  ; toggle a
        mov     r6, a
wait_gelber:
        mov     dptr, #PINSC           ; Schiebe Adresse fr Pins an Port-C nach dprt
        movx    a, @dptr               ; lese Eingaben von Port-C nach a
        mov     0x20, a                ; speichere in bitadressierbaren speicher
        mov     c, 2                   ; speichere rote schalter in c (low aktiv!)
        jnc     wait_gelber            ; wenn roter schalter gedrckt ist
        sjmp    l1                     ; schalter wurde losgelassen
