; Konstantenvereinbarungen
.equ BIT_REG0,  0x20
.equ BIT_REG1,  0x21
.equ STACK,     0x80

; Reset-Vektor zeigt hier hin
        .org    0x0000
        sjmp    init                 ; Sprung zu eigentlichem Programmstart

; Eigenlicher Programmanfang
        .org    0x0080
init:
        mov     sp, #STACK - 1       ; Stackpointer auf Position 0x79 (Stack: 0x80-0xff ind. adr. Speicher)
        mov     BIT_REG0, #1b        ; Schreibe auf bit-adressierbare Adresse 0x20
        mov     BIT_REG1, #1b        ; Schreibe auf bit-adressierbare Adresse 0x21
        clr     c                    ; l�che Carry (c=0)
        orl     c, 0                 ; or carry mit bit 0 des bit-adressierbaren Speichers (c=1)
        anl     c, 8                 ; and carry mit bit 8 des bit-adressierbaren Speichers (c=1

        mov     r0, #0x20            ; Schiebe Zahl 0x20=32 in r0
        mov     a, #01111111b        ; Schiebe 01111111b=127=7fh in Akkumulator
        mov     @r0, a               ; Schreibe an Adresse r0 (0x20) a (127)

        mov     r0, #0x21            ; Schiebe Zahl 0x21=33 in r0
        mov     a, #10000000b        ; Schiebe 10000000b=128=80h in Akkumulator
        mov     @r0, a               ; Schreibe an Adresse r0 (0x21) a (128)

        clr a                        ; setze a auf 0

        mov     r0, #0x20            ; Schiebe Zahl 0x20=32 in r0
        add     a, @r0               ; addiere r0 zu a -> a=20h=32
        mov     r0, #0x21            ; Schiebe Zahl 0x21=33 in r0
        add     a, @r0               ; addiere r0 zu a -> a=ffh=255

; Endlosschleife
l1:
        sjmp l1
